#ifndef _hid_keycodes_h__
#define _hid_keycodes_h__

/* From Hut1_12.pdf : Universal Serial Bus HID Usage Tables, 
 * section 10 Keyboard/Keypad Page (0x07) */

#define HID_KB_NOEVENT	0x00

#define HID_KB_A		0x04
#define HID_KB_B		0x05
#define HID_KB_C		0x06
#define HID_KB_D		0x07
#define HID_KB_E		0x08
#define HID_KB_F		0x09
#define HID_KB_G		0x0a
#define HID_KB_H		0x0b
#define HID_KB_I		0x0c
#define HID_KB_J		0x0d
#define HID_KB_K		0x0e
#define HID_KB_L		0x0f
#define HID_KB_M		0x10
#define HID_KB_N		0x11
#define HID_KB_O		0x12
#define HID_KB_P		0x13
#define HID_KB_Q		0x14
#define HID_KB_R		0x15
#define HID_KB_S		0x16
#define HID_KB_T		0x17
#define HID_KB_U		0x18
#define HID_KB_V		0x19
#define HID_KB_W		0x1a
#define HID_KB_X		0x1b
#define HID_KB_Y		0x1c
#define HID_KB_Z		0x1d

#define HID_KB_1		0x1e
#define HID_KB_2		0x1f
#define HID_KB_3		0x20
#define HID_KB_4		0x21
#define HID_KB_5		0x22
#define HID_KB_6		0x23
#define HID_KB_7		0x24
#define HID_KB_8		0x25
#define HID_KB_9		0x26
#define HID_KB_0		0x27

#define HID_KB_ESCAPE			0x29
#define HID_KB_BACKSPACE		0x2a
#define HID_KB_TAB				0x2b

#define HID_KB_SPACE			0x2c
#define HID_KB_DASH_UNDERSCORE	0x2d
#define HID_KB_EQUAL_PLUS		0x2e
#define HID_KB_OPEN_BRKT_BRACE	0x2f

#define HID_KB_CLOSE_BRKT_BRACE	0x30
#define HID_KB_NONUS_HASH_TILDE	0x32
#define HID_KB_SEMI_COLON_COLON	0x33
#define HID_KB_QUOTES			0x34
#define HID_KB_GRAVE_ACCENT_AND_TILDE	0x35
#define HID_KB_COMMA_SMALLER_THAN		0x36
#define HID_KB_PERIOD_GREATER_THAN		0x37
#define HID_KB_SLASH_QUESTION	0x38
#define HID_KB_CAPS_LOCK		0x39

#define HID_KB_F1				0x3a
#define HID_KB_F2				0x3b
#define HID_KB_F3				0x3c
#define HID_KB_F4				0x3d
#define HID_KB_F5				0x3e
#define HID_KB_F6				0x3f
#define HID_KB_F7				0x40
#define HID_KB_F8				0x41
#define HID_KB_F9				0x42
#define HID_KB_F10				0x43
#define HID_KB_F11				0x44
#define HID_KB_F12				0x45

#define HID_KB_SCROLL_LOCK		0x47
#define HID_KB_INSERT			0x49
#define HID_KB_HOME				0x4a
#define HID_KB_PGUP				0x4b
#define HID_KB_DELETE_FORWARD	0x4c
#define HID_KB_END				0x4d
#define HID_KB_PGDN				0x4e

#define HID_KB_RIGHT_ARROW		0x4f
#define HID_KB_LEFT_ARROW		0x50
#define HID_KB_DOWN_ARROW		0x51
#define HID_KB_UP_ARROW			0x52

#define HID_KB_ENTER			0x28

#define HID_KB_INTERNATIONAL1	0x87
#define HID_KB_INTERNATIONAL2	0x88
#define HID_KB_INTERNATIONAL3	0x89
#define HID_KB_INTERNATIONAL4	0x8a
#define HID_KB_INTERNATIONAL5	0x8b

#define HID_KB_LEFT_CONTROL		0xe0
#define HID_KB_LEFT_SHIFT		0xe1
#define HID_KB_LEFT_ALT			0xe2
#define HID_KB_LEFT_GUI			0xe3
#define HID_KB_RIGHT_CONTROL	0xe4
#define HID_KB_RIGHT_SHIFT		0xe5
#define HID_KB_RIGHT_ALT		0xe6
#define HID_KB_RIGHT_GUI		0xe7

#endif // _hid_keycodes_h__

